

#ifndef _SDL_BUTTON_H_
#define _SDL_BUTTON_H_

#include <SDL2/SDL.h>
#include <SDL_keyboard.h>

#include "common.h"

typedef struct{
  Uint8 scancode;
  SDL_Keycode sym;
  SDL_Keymod mod;
  Uint16 unicode;
} SDL_keysym;

typedef struct SDL_Button SDL_Button;
struct SDL_Button
{
    SDL_Surface *image;

    SDL_Rect dest;
    SDL_Rect src;

    Boolean is_rolled_over;
    Boolean is_holding_click;
    Boolean is_clicked;
    Boolean is_released;
};


void SDL_Button_Initialize( SDL_Button *button, int x, int y, SDL_Surface *image );


void SDL_Button_Update( SDL_Button *button, SDL_Event event );

void SDL_Button_Display( SDL_Button button, SDL_Surface *screen );


Boolean SDL_Button_IsRolledOver( SDL_Button button );


Boolean SDL_Button_IsClicked( SDL_Button button );


Boolean SDL_Button_IsReleased( SDL_Button button );

#endif /* _SDL_BUTTON_H_ */
