

#ifndef _SDL_INPUTBOX_H_
#define _SDL_INPUTBOX_H_


#include "common.h"
#include <SDL2/SDL_ttf.h>


#define INPUTBOX_WRITE_RATE 150


typedef struct SDL_InputBox SDL_InputBox;
struct SDL_InputBox
{
    SDL_Surface *image;

    SDL_Rect dest;
    SDL_Rect src;

    char *text;
    int cur_index;
    int max_size_text;

    Boolean is_activ;
    Boolean is_full;

    int last_letter;
    int cur_letter;
    int last_write;

    int off_text_x, off_text_y;
    TTF_Font *font;
    SDL_Color color_font;
    SDL_Surface *image_text;
};


void SDL_InputBox_Initialize( SDL_InputBox *input_box, int x, int y, SDL_Surface *image, int max_size_text, int off_text_x, int off_text_y, TTF_Font *font, SDL_Color color_font );


char* SDL_InputBox_GetText( SDL_InputBox *input_box );


void SDL_InputBox_SetText( SDL_InputBox *input_box, const char *text );


int SDL_InputBox_GetSizeText( SDL_InputBox input_box );


int SDL_InputBox_GetMaxSizeText( SDL_InputBox input_box );


void SDL_InputBox_Update( SDL_InputBox *input_box, SDL_Event event );


void SDL_InputBox_Display( SDL_InputBox input_box, SDL_Surface *screen );


Boolean SDL_InputBox_IsActiv( SDL_InputBox input_box );


Boolean SDL_InputBox_IsFull( SDL_InputBox input_box );


void SDL_InputBox_Free( SDL_InputBox input_box );

#endif /* _SDL_INPUTBOX_H_ */
