
#include "menu.h"


int menu_principal(SDL_Rect positionFond,SDL_Surface *ecran)
{
    int i;
    SDL_Event event;
    Menu menu;

    init_imagesmenu(&menu);

    init_menu(&menu,positionFond,ecran);

    while( SDL_Button_IsClicked( menu.buttons[quit] ) == false )
    {
        update_menu(&menu, &event);

        if( SDL_Button_IsClicked( menu.buttons[playmenu] ) == true )
        {
            for( i = 0 ; i < NB_Images_MENU ; i++ )
            SDL_FreeSurface( menu.surf[ i ] );
            return 1;
        }


        if( SDL_Button_IsClicked( menu.buttons[explain] ) == true )
        {
            for( i = 0 ; i < NB_Images_MENU ; i++ )
            SDL_FreeSurface( menu.surf[ i ] );
            return 2;
        }

        display_menu(&menu,ecran);

    }

    for( i = 0 ; i < NB_Images_MENU; i++ )
        SDL_FreeSurface( menu.surf[ i ] );
    return 0;

}

void init_imagesmenu(Menu* menu)
{
    menu->surf[ 0 ] = SDL_LoadBMP( "../project/resources/images/BEGIN.bmp");
    menu->surf[ 1 ] = SDL_LoadBMP( "../project/resources/images/QUIT.bmp" );
    menu->surf[ 2 ] = SDL_LoadBMP( "../project/resources/images/PLAY.bmp" );
    menu->surf[ 3 ] = SDL_LoadBMP( "../project/resources/images/EXPLAIN.bmp" );

}

void init_menu(Menu* menu,SDL_Rect positionFond,SDL_Surface *ecran)
{
    SDL_BlitSurface(menu->surf[ 0 ], NULL, ecran, &positionFond);
    SDL_Button_Initialize( &(menu->buttons[quit]), 300, 450, menu->surf[ 1 ] );
    SDL_Button_Initialize( &(menu->buttons[playmenu]), 300, 200, menu->surf[ 2 ] );
    SDL_Button_Initialize( &(menu->buttons[explain]), 300, 325, menu->surf[ 3 ] );
}

void update_menu(Menu* menu, SDL_Event* event)
{
        int i;
        SDL_PollEvent( event );
        for(i=0;i<NB_BUTTONS_MENU;i++)
            SDL_Button_Update( &(menu->buttons[i]), *event );

}

void display_menu(Menu* menu,SDL_Surface *ecran)
{
        SDL_Button_Display( menu->buttons[quit], ecran );
        SDL_Button_Display( menu->buttons[playmenu], ecran );
        SDL_Button_Display( menu->buttons[explain], ecran );


        SDL_RenderPresent( ecran );
}


