#include <stdio.h>
#include <stdlib.h>
#include "deroulement.h"
#include "manches.h"
#include "ascii_art.h"

/**
 * \fn int compterNombre(Joueur*J,int valeur)
 * \brief compte le nombre de des d'une certaine valeur en jeu
 *
 *\param Joueur*J debut de  la  liste de joueur
 * \return nombre d'occurence de la valeur
 */

int compterNombre(Joueur*J,int valeur)
{
    int i,k,res=0;
    for (i=0; i<numJoueur; i++)
    {
        for (k=0; k<J->nombreDes; k++)
        {
            if(valeur==J->des[k])res++;
        }
        J=J->next;
    }
    return res;
}

/**
 * \fn void afficheNombreDes(Joueur *J)
 * \brief affiche le nombre de des de chaque joueur
 *
 *\param Joueur*J debut de  la  liste de joueur
 */

void afficheNombreDes(Joueur *J)
{
    int i;
    printf("\n");
    for (i=0; i<numJoueur; i++)
    {
        printf("Nombre de des de joueur \"%s\": %d\n",J->nom,J->nombreDes);
        J=J->next;
    }
    printf("\n");
}

/**
 * \fn void afficheDes(Joueur* current)
 * \brief affiche les des du joueur en paramétre
 *
 *\param Joueur*J joueur dont on veut affiche les des
 */

void afficheDes(Joueur* current)
{
    int i;
    printf("Pour le joueur \"%s\", ",current->nom);
    printf("ses des sont: ");
    for (i=0; i<current->nombreDes; i++)
    {
        (current->des[i]==1)?printf("paco "):printf("%d ", current->des[i]);
    }
    // ICI vous devrez faire vous même ce qu'il faut pour afficher les bons dés.
    // TODO trouvez une solution pour en afficher 3/ligne par exemple
    for (i=0; i<current->nombreDes; i++)
    {
        print_dice(current->des[i]);
    }

    printf("\n");
}



/**
 * \fn affichTousDes(Joueur* current)
 * \brief affiche les des de tout les joueurs
 *
 *\param Joueur*J debut de  la  liste de joueur
 */


void affichTousDes(Joueur* current)
{
    int i;
    for(i=0; i<numJoueur; i++)
    {
        afficheDes(current);
        current=current->next;
    }
    return;
}

/**
 * \fn void afficheAnnonce(Annonce* debut,Joueur* premier)
 * \brief affiche l'annonce fais par tout les joueurs
 *
 *\param Annonce* debut première annonce du joueur ,Joueur* premier joueur
 */

void afficheAnnonce(Annonce* debut,Joueur* premier)
{

    printf("\n");
    while (debut!=NULL)
    {
        printf("Le joueur \"%s\" a declare au moin %d des de ",premier->nom,debut->nombre);
        (debut->valeur==1)?printf("paco ;"):printf("%d ;",debut->valeur);
        printf("\n");
        premier=premier->next;
        debut=debut->next;
    }
    printf("\n");
}

/**
 * \fn void afficheetatjoueur(Annonce* debut,Joueur* J)
 * \brief affiche l'annonce fais par tout les joueurs ainsi que leur des
 *
 *\param Annonce* debut première annonce ,Joueur* premier joueur
 */

void afficheetatjoueur(Annonce* debut,Joueur* J)
{
    int i=0;
    int numA=tailleListeA(debut);
    printf("\n");
    while (i<numJoueur || debut!=NULL)
    {
        if(i>= numA-numJoueur){
            printf("joueur %s - %d des ",J->nom,J->nombreDes);
            if (debut!=NULL){
            printf( "dernier pari %d des de",debut->nombre);
            (debut->valeur==1)?printf("paco \n"):printf("%d \n",debut->valeur);
            }else{printf("\n");}
        }
        if(debut!=NULL){debut=debut->next;}
        i++;
        J=J->next;
    }
    printf("\n");
}

/**
 * \fn void ResDudo(Joueur *J,Annonce *a,int i,int palifico)
 * \brief annonce le resultat d'un dudo
 *
 *\param Joueur *J le joueur concerné par le dudo ,Annonce *a l'annonce concerné,int i definit si il y a succées ou echec ,int palifico definit si palico ou non
 */

//palico=1,manche de palifico
void ResDudo(Joueur *J,Annonce *a,int i,int palifico)//i=1,mode d'affichage pour dudo avec succes;i=2.quand il y a un echec
{
    if(a->valeur==1)
    {
        printf("\nDonc on peut voir qu'il y a %d des de paco",compterNombre(J,1));
    }
    else
    {

        if(palifico==1)
        {
            printf("\nDonc on peut voir qu'il y a %d des de %d",compterNombre(J,a->valeur),a->valeur);
        }
        else
        {
            printf("\nDonc on peut voir qu'il y a %d des de %d",compterNombre(J,1)+compterNombre(J,a->valeur),a->valeur);
        }
        (i==1)?printf(",ce qui ne correspond pas a la proposition\n"):printf(",ce qui correspond a la proposition\n");
        printf("Par consequent,le joueur \"%s\" a perdu un de.\n",J->nom);
        J->nombreDes--;
        //printf("nombre des %d",J->nombreDes); //LIGNE POUR TESTER
    }

}

/**
 * \fn void verifieNombre(Annonce* a)
 * \brief verifie que le nombre de des de l'annonce est coherent
 *
 *\param Annonce* a Annonce dont on veut verifier la cohérence
 */
void verifieNombre(Annonce* a)
{
    while(a->nombre>5*numJoueur||a->nombre==0)
    {
        printf("Le nombre du de n'est pas valide!");
        printf("Veuillez-vous resaisir: ");
        scanf("%d", &(a->nombre));
        getchar();
    }
    return;
}

/**
 * \fn void verifieValeur(Annonce* a)
 * \brief verifie que le valeur de des de l'annonce est coherent
 *
 *\param Annonce* a Annonce dont on veut verifier la cohérence
 */

void verifieValeur(Annonce* a)
{
    while(a->valeur>6||a->valeur<1)
    {
        printf("La valeur du de n'est pas valide!");
        printf("Veuillez-vous resaisir: ");
        scanf("%d", &(a->valeur));
        getchar();
    }
}

/**
 * \fn Annonce* listeAnnonce(Joueur* J,int palifico)
 * \brief gère la création d'annonce par le joueur
 *
 *\param Joueur* J joueur qui fait l'annonce, int palifico si =1 palifico sinon non
 */

Annonce* listeAnnonce(Joueur* J,int palifico)//creation de la liste d'annonce.Quand palifico=1 mode palifico,;0,mode normal
{
    Annonce *a,*nextA,*head;
    Joueur *nextJ,*premier=J;
    int i;
    if(palifico==1)
    {
        premier->dejaPlifico=1;
        printf("Selon le regle, le joueur \"%s\" est palifico.\n",premier->nom);
        printf("Les joueur suivant ne peuvent pas modifier la valeur de de.\n\n");
    }
    printf("Nous commencon a jouer par la declaration des annonces.\n");
    printf("Le permier joueur \"%s\" doit faire une proposition.\n ",J->nom);
    presenceJoueur(J);
    printf("\n");
    afficheDes(J);
    a= (Annonce*) malloc(sizeof(Annonce));
    head = a;
    printf("\nQuelle est votre valeur du de pour la proposition?\n");
    scanf("%d",&(a->valeur));
    getchar();
    if(palifico==0)
    {
        while(a->valeur==1)
        {
            printf("Comme le premier joueur, vous ne pouvez pas commencer par \"Paco\"!\n");
            printf("Veuillez-vous resaisir: ");
            scanf("%d", &(a->valeur));
            getchar();
        }
    }
    verifieValeur(a);

    printf("Quelle est votre nombre des des pour la proposition? \n");

    scanf("%d",&(a->nombre));
    getchar();
    verifieNombre(a);
    printf("Donc votre declaration est qu'il y a au moin %d des de %d au total.\n",a->nombre,a->valeur);
    while (1)
    {

        nextJ=J->next;
        MultiSuivant(1);
        system("clear");
        presenceJoueur(J->next);
        //afficheAnnonce(head,premier);
        //afficheNombreDes(J);
        afficheetatjoueur(head,premier); //remplace afficheAnnonce et afficheNombresDes

        afficheDes(J->next);
        a->next= (Annonce*) malloc(sizeof(Annonce));
        nextA=a->next;
        if (J->humain==1){
            if(palifico==0)
            {
                (a->valeur==1)?printf("\nIl y a trois types d'annonce: 1.Surenchere 2.Dudo 4.EnlevePaco\n"):printf("\nIl y a trois types d'annonce: 1.Surenchere 2.Dudo 3.Paco\n");
            }
            else
            {
                printf("\nIl y a deux types d'annonce: 1.Surenchere 2.Dudo\n");
            }
            printf("Veuillez-vous saisir votre option en tapant le numero corespondant: ");
            scanf("%d",&i);
            getchar();
                }else{
                i=IA;
                }

        enum choix option=(enum choix)i;
        switch (option)
        {
        case IA:
            nextA->nombre = a->nombre+1;
            nextA->valeur = a->valeur;
            break;
        case surenchere:
            printf("\nVeuillez-vous saisir le nombre de des de votre pari: ");
            scanf("%d",&(nextA->nombre));
            getchar();
            verifieNombre(nextA);
            if(palifico==0)
            {
                while(nextA->nombre<a->nombre)
                {
                    printf("\nLe nombre de des doit etre plus grand ou egal a celui du dernier joueur!\n");
                    printf("Veuillez-vous resaisir: ");
                    scanf("%d",&(nextA->nombre));
                    getchar();
                }
                if(nextA->nombre==a->nombre)
                {

                    printf("\nVeuillez-vous saisir la valeur de des ");
                    scanf("%d",&(nextA->valeur));
                    getchar();
                    verifieValeur(nextA);
                    while((nextA->valeur<=a->valeur)&&(a->valeur!=6))
                    {
                        printf("\nLa valeur de des doit etre plus grande que celui du dernier joueur!\n");
                        printf("Veuillez-vous resaisir: ");
                        scanf("%d",&(nextA->valeur));
                        getchar();

                    }
                    if(a->valeur==6)
                    {
                        printf("veuillez-vous augumenter le nombre de des que vous venez de saisir: ");
                        scanf("%d",&(nextA->nombre));
                        getchar();
                        nextA->valeur=6;
                    }

                }
            }
            else
            {

                while(nextA->nombre<=a->nombre)
                {
                    printf("\nLe nombre de des doit etre strictement superieur que celui du dernier joueur!\n");
                    printf("Veuillez-vous resaisir: ");
                    scanf("%d",&(nextA->nombre));
                    getchar();
                }
            }
            if(nextA->nombre>a->nombre)
            {
                printf("\nSelon le regle du jeu, votre valeur de des est ");
                (a->valeur==1)?printf("paco "):printf("%d ",a->valeur);
                printf("\n");
                nextA->valeur=a->valeur;
            }
            printf("Donc votre proposition est qu'il y a au moin %d des de ",nextA->nombre);
            (nextA->valeur==1)?printf("paco ;\n\n"):printf("%d ;\n\n",nextA->valeur);
            a = a->next;
            break;
        case paco:
            nextA->nombre=annoncePaco(a);
            nextA->valeur=1;
            a = a->next;
            break;
        case enlevepaco:
            nextA->nombre=a->nombre*2+1;
            printf("\nVeuillez-vous saisir la valeur de des pour remplacer paco: ");
            scanf("%d",&(nextA->valeur));
            getchar();
            while(nextA->valeur==1)
            {
                printf("\nVeuillez-vous saisir une valeur de des a part paco(1 pour representer paco): ");
                scanf("%d",&(nextA->valeur));
                getchar();
            }
            printf("\nDonc votre pari: Il y a au moins %d de %d.\n",nextA->nombre,nextA->valeur);
            a = a->next;
            break;

        case dudo:
            system("clear");
            printf("Vous avez choisi de douter du pari precedent!\n\n");
            affichTousDes(J);
            if(palifico==0)
            {
                if(a->valeur==1)
                {
                    if(compterNombre(J,1)<a->nombre)
                    {
                        ResDudo(J,a,1,0);
                        nextA->valeur=1;
                    }
                    else
                    {
                        ResDudo(nextJ,a,2,0);
                        nextA->valeur=2;
                    }

                }
                else
                {
                    if((compterNombre(J,1)+compterNombre(J,a->valeur))<a->nombre)
                    {
                        ResDudo(J,a,1,0);
                        nextA->valeur=1;
                    }
                    else
                    {
                        ResDudo(nextJ,a,2,0);
                        nextA->valeur=2;
                    }


                }
            }
            else
            {
                if(compterNombre(J,a->valeur)<a->nombre)
                {
                    ResDudo(J,a,1,1);
                    nextA->valeur=1;
                }
                else
                {
                    ResDudo(nextJ,a,2,1);
                    nextA->valeur=2;
                }

            }
            return head;
        }

        J=J->next;

    }


}

/**
 * \fn int annoncePaco(Annonce* current)
 * \brief gère la decision paco dans la fct listeAnnonce
 *
 *\param Annonce* current annonce precedante
 * \return int res le nombre de dès de paco du pari
 */

int annoncePaco(Annonce* current)
{
    int res;
    //Annonce *res= (Annonce*) malloc(sizeof(Annonce));
    res=(int)((double)current->nombre/2+0.5);
    printf("\nDonc votre pari: Il y a au moins %d de pacos.\n\n",res);
    return res;
}

