#include <string.h>
#ifndef _INITIALISATION_H
#define _INITIALISATION_H

#define MAX_DES 30
#define MAX_JOUEURS 6

extern int numJoueur;

/**
 * \struct Joueur
 * \brief dfinit un joueur par son nom
 * et contient des information utile
 */


 struct Joueur
{
    char nom[20]; /*!< Chane de caractere :du nom du joueur. */
    int nombreDes;  /*!< entier :nombre de des restant au joueur. */
    int des[5]; /*!<tableau d'entier :resultat de ses des lors de cette manche. */
    int dejaPlifico; /*!< si le joueur a deja passe un manche de palifico cette valeur est nulle. Sinon dejaPlifico=1 */
    struct Joueur *next; /*!< prochain joueur  */
    int humain; /*!< =0 si le joueur est une IA */
};
typedef struct Joueur Joueur;


/**
 * \struct Annonce
 * \brief definit une annonce
 *  contient la valeur sur la quelle est fais l'annonce
 *  et la face du des sur laquelle elle porte
 */

struct Annonce
{
     int nombre; /*!< nombre de des de l'annonce */
     int valeur; /*!< face du de sur laquelle l anonnce porte */
    struct Annonce *next;
} ;
typedef struct Annonce Annonce;
//pour le'annonce type dudo,il n'y a que sa valeur qui n'est pas null.
//Pour sa valeur, 1 represente un dudo avec succes, 2 represent un dudo non reussi.

/**
 * \struct ListJoueur
 * \brief liste des joueurs dans l'ordre de jeu
 *
 */

struct ListJoueur
{
    Joueur *first; /*!< premier joueur  */
    Joueur *current; /*!< joueur courrant */
} ;
typedef struct ListJoueur ListJoueur;

Joueur* saisirJoueur();

void inputPlayersNum();

int randInt(int max);

Joueur* getPremierJoueur(Joueur* head);

Joueur* getJoueur(Joueur* head, int num);

void distribuerDes(Joueur* p);
void presenceJoueur(Joueur* current);

void MultiSuivant(int i);

#endif // _INITIALISATION_H
