#include <stdio.h>
#include <stdlib.h>
#include "manches.h"
#include "deroulement.h"

/**
 * \fn Annonce* getAnnonce(Annonce* head, int num)
 * \brief fonction qui permet de recuperer l'annonce d'un joueur
 *
 *\param Annonce* head premire annonce de la liste , int num numro de l'annonce voulue
 * \return Annonce* annonce voulue
 */

Annonce* getAnnonce(Annonce* head, int num)
{
    int i = 0;
    Annonce *tmp = head;
    for (i = 0; i < num; i++)
        tmp = tmp->next;
    return tmp;
}

/**
 * \fn tailleListeA(Annonce *a)
 * \brief fonction qui donne la taille de la liste d'annonce
 *
 *\param Annonce* a premire annonce de la liste
 * \return int la taille de la liste
 */

int tailleListeA(Annonce *a)
{
    int taille=1;
    if(a!=NULL)
    {
        while(a->next!=NULL)
        {
            taille++;
            a=a->next;
        }
        return taille;
    }
    return 0;
}

/**
 * \fn Joueur* eliminerJoueur(Joueur* premier)
 * \brief fonction permettant de trouver le joueur a eleminer.
 * S'il y en a pas, retourner un pointeur null.
 *
 *\param Joueur* premier premier joueur de la liste
 * \return Joueur* joueur a liminer ou pointeur null si il n'y en a pas
 */

Joueur* eliminerJoueur(Joueur* premier)
{
    int i;
    for(i=0; i<numJoueur; i++)
    {
        if(premier->nombreDes==0)return premier;
        premier=premier->next;
    }
    return NULL;
}

/**
 * \fn deterPerdant(Annonce* head)
 * \brief rend le nombre de pas pour passer au joueur perdant
 *
 *\param Annonce* head premire annonce de la liste
 * \return int nombre de pas
 */

int deterPerdant(Annonce* head)
{
    Annonce* current=head;
    while(current->next!=NULL)
    {
        current=current->next;
    }
    return(current->valeur==1)?(tailleListeA(head)-2):(tailleListeA(head)-1);
}

/**
 * \fn Joueur* supprimeJoueur(Joueur* perdant)
 * \brief fonction qui sert a supprimer le joueur perdant et retablir la liste des joueurs
 *
 *\param Joueur* perdant le k=joueur a liminer
 * \return Joueur return le joueur suivant
 */

Joueur* supprimeJoueur(Joueur* perdant)
{
    Joueur* ancien=getJoueur(perdant,numJoueur-1);
    ancien->next=perdant->next;
    free(perdant);
    return ancien->next;

}
/**
 * \fn void derouleLesManches(Joueur* premier)
 * \brief fonction qui permet d'effectuer le deroulement d'une manche
 *
 *\param Joueur* premier premier joueur.
 */

void derouleLesManches(Joueur* premier)
{

    while(numJoueur!=1)
    {

        while (eliminerJoueur(premier)==NULL)
        {
            distribuerDes(premier);
            Annonce* head=(premier->nombreDes==1&&premier->dejaPlifico==0)?listeAnnonce(premier,1):listeAnnonce(premier,0);
            MultiSuivant(2);
            system("clear");
            premier=getJoueur(premier,deterPerdant(head));
            if(numJoueur!=1)printf("Comme le joueur \"%s\" vient de perdre un de, \nil est pris comme le premier joueur de ce manche.\n",premier->nom);

        }
        numJoueur--;
        Joueur* perdant=eliminerJoueur(premier);
        printf("Vue que le joueur \"%s\" n'a plus de de disponible,il va etre elimine de cette partie!",perdant->nom);
        premier=supprimeJoueur(perdant);
        if(numJoueur!=1)printf("\nDonc le joueur a sa gauche est devenu le premier.\n");

    }
    printf("\n\nIl ne reste qu'un joueur. Felicitation! Le vainqueur de cette partie est \"%s\".",premier->nom);
}




