

#pragma once
#include <stdbool.h>

#define MAX(x, y) ((x) > (y) ? (x) : (y))
#define MIN(x, y) ((x) < (y) ? (x) : (y))
#define CLAMP(v, _min, _max) MAX((_min), MIN((_max), (v))) //若v在[min,max]范围内，则等于v；如果v小于min，则返回min；如果v大于max，则返回max。

typedef struct
{
	int x;
	int y;
} Vec2i;

Vec2i Vec2iNew(int x, int y);
Vec2i Vec2iZero(void); //(0, 0)
Vec2i Vec2iUnit(void);	// (1, 1)
Vec2i Vec2iAdd(Vec2i a, Vec2i b);
Vec2i Vec2iMinus(Vec2i a, Vec2i b);

Vec2i Vec2iMult(const Vec2i a, const Vec2i b);
Vec2i Vec2iScale(Vec2i v, int scalar);
Vec2i Vec2iScaleDiv(Vec2i v, int scaleDiv);

bool Vec2iEqual(const Vec2i a, const Vec2i b);
bool Vec2iIsZero(const Vec2i v);
Vec2i Vec2iNorm(Vec2i v);
Vec2i Vec2iClamp(Vec2i v, Vec2i lo, Vec2i hi);

int DistanceSquared(Vec2i a, Vec2i b);
